commit 8278cff1fb9b7ed41ef477adefd7dabaf617bfde
Author: jklowden <jklowden>
Date:   Fri Apr 30 21:59:42 2010 +0000

    initilize client charset per setlocale(3) and friends

diff --git a/ChangeLog b/ChangeLog
index a2b037d..015df49 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,6 @@
+Fri Apr 30 17:57:22 EDT 2010	JK Lowden <jklowden@freetds.org>
+	* src/tds/mem.c initilize client charset per setlocale(3) and friends
+
 Mon Apr 26 11:09:11 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/ctlib/ct.c src/ctlib/unittests/t0007.c:
 	- fix maxlength returned by ct_describe for numeric types
@@ -2410,4 +2413,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3012 2010/04/26 09:09:48 freddy77 Exp $
+$Id: ChangeLog,v 1.3013 2010/04/30 21:59:42 jklowden Exp $
diff --git a/src/tds/mem.c b/src/tds/mem.c
index c17209b..4624330 100644
--- a/src/tds/mem.c
+++ b/src/tds/mem.c
@@ -37,11 +37,23 @@
 #include "replacements.h"
 #include "enum_cap.h"
 
+#ifdef STRING_H
+#include <string.h>
+#endif
+
+#ifdef HAVE_LOCALE_H
+#include <locale.h>
+#endif /* HAVE_LOCALE_H */
+
+#ifdef HAVE_LANGINFO_H
+#include <langinfo.h>
+#endif /* HAVE_LANGINFO_H */
+
 #ifdef DMALLOC
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: mem.c,v 1.196 2010/01/11 18:14:10 freddy77 Exp $");
+TDS_RCSID(var, "$Id: mem.c,v 1.197 2010/04/30 21:59:43 jklowden Exp $");
 
 static void tds_free_env(TDSSOCKET * tds);
 static void tds_free_compute_results(TDSSOCKET * tds);
@@ -678,8 +690,29 @@ TDSLOCALE *
 tds_alloc_locale(void)
 {
 	TDSLOCALE *locale;
+#if !(HAVE_NL_LANGINFO && defined(CODESET))
+	char *lc_all;
+#endif
 
 	TEST_MALLOC(locale, TDSLOCALE);
+
+	locale->client_charset = strdup("ISO-8859-1"); 
+	
+#if HAVE_NL_LANGINFO && defined(CODESET)
+	locale->client_charset = nl_langinfo(CODESET);
+#else
+	if ((lc_all = strdup(setlocale(LC_ALL, NULL)) == NULL)
+		goto Cleanup;
+
+	if (strtok(lc_all, ".")) {
+		char *encoding = strtok(NULL, "@");
+		if (encoding) {
+			locale->client_charset = strdup(encoding);
+		}
+	}
+#endif
+	tdsdump_log(TDS_DBG_FUNC, "tds_alloc_locale(): initialized locale to \"%s\"\n", locale->client_charset? locale->client_charset : "NULL");
+
 	return locale;
 
       Cleanup:

